package com.zksy.system.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.zksy.common.PinYinUtils;
import com.zksy.common.annotation.DataScope;
import com.zksy.common.constant.UserConstants;
import com.zksy.common.core.domain.entity.SysDept;
import com.zksy.common.core.domain.entity.SysRole;
import com.zksy.common.core.domain.entity.SysUser;
import com.zksy.common.core.domain.model.LoginUser;
import com.zksy.common.exception.ServiceException;
import com.zksy.common.utils.SecurityUtils;
import com.zksy.common.utils.StringUtils;
import com.zksy.common.utils.bean.BeanUtils;
import com.zksy.common.utils.bean.BeanValidators;
import com.zksy.common.utils.result.Response;
import com.zksy.common.utils.spring.SpringUtils;
import com.zksy.system.domain.SysPost;
import com.zksy.system.domain.SysUserPost;
import com.zksy.system.domain.SysUserRole;
import com.zksy.system.mapper.*;
import com.zksy.system.model.request.*;
import com.zksy.system.model.respone.OrgAccPageVo;
import com.zksy.system.model.respone.OrgAccRcord;
import com.zksy.system.model.respone.SysUserRes;
import com.zksy.system.service.ISysConfigService;
import com.zksy.system.service.ISysDeptService;
import com.zksy.system.service.ISysUserService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;
import org.springframework.util.ObjectUtils;

import javax.annotation.Resource;
import javax.validation.Validator;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 用户 业务层处理
 *
 * @author ruoyi
 */
@Service
public class SysUserServiceImpl extends ServiceImpl<SysUserMapper, SysUser> implements ISysUserService {
    private static final Logger log = LoggerFactory.getLogger(SysUserServiceImpl.class);

    @Resource
    private SysUserMapper userMapper;

    @Resource
    private SysRoleMapper roleMapper;

    @Resource
    private SysPostMapper postMapper;

    @Resource
    private SysUserRoleMapper userRoleMapper;

    @Resource
    private SysUserPostMapper userPostMapper;

    @Autowired
    private ISysConfigService configService;

    @Resource
    protected Validator validator;

    @Autowired
    private ISysDeptService deptService;

    @Resource
    private SysDeptMapper deptMapper;

    /**
     * 根据条件分页查询用户列表烦烦烦
     *
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    @Override
    @DataScope(deptAlias = "d", userAlias = "u")
    public List<SysUser> selectUserList(SysUserListReq user) {
        return userMapper.selectUserList(user);
    }

    /**
     * 通过机构ID获取用户列表
     *
     * @param req
     * @return
     */
    @Override
    public Response<SysUserRes> searchSysUserList(SearchSysUserReq req) {
        Long deptId = SecurityUtils.getDeptId();
        List<SysDept> sysDepts = deptMapper.selectLevelAndChild(deptId);
        req.setDepts(sysDepts);
        Page<SysUserRes> page = PageHelper.startPage(req.getPageNumber(), req.getPageSize());
        List<SysUser> sysUsers = userMapper.searchSysUserList(req);
        SysUserRes res = new SysUserRes();
        res.setRecords(sysUsers);
        res.setCurrPage(req.getPageNumber());
        res.setPageSize(req.getPageSize());
        res.setTotalRecord(Long.valueOf(page.getTotal()).intValue());
        return Response.success(res);
    }

    /**
     * 根据条件分页查询已分配用户角色列表
     *
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    @Override
    @DataScope(deptAlias = "d", userAlias = "u")
    public List<SysUser> selectAllocatedList(SysUser user) {
        return userMapper.selectAllocatedList(user);
    }

    /**
     * 根据条件分页查询未分配用户角色列表
     *
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    @Override
    @DataScope(deptAlias = "d", userAlias = "u")
    public List<SysUser> selectUnallocatedList(SysUser user) {
        return userMapper.selectUnallocatedList(user);
    }

    /**
     * 通过用户名查询用户
     *
     * @param userName 用户名
     * @return 用户对象信息
     */
    @Override
    public SysUser selectUserByUserName(String userName) {
        return userMapper.selectUserByUserName(userName);
    }

    /**
     * 通过用户ID查询用户
     *
     * @param userId 用户ID
     * @return 用户对象信息
     */
    @Override
    public SysUser selectUserById(Long userId) {
        return userMapper.selectById(userId);
    }


    /**
     * 通过用户ID查询用户
     *
     * @param userId 用户ID
     * @return 用户对象信息
     */
    @Override
    public SysUser selectUserById4New(Long userId) {
        return userMapper.selectUserById(userId);
    }

    /**
     * 查询用户所属角色组
     *
     * @param userName 用户名
     * @return 结果
     */
    @Override
    public String selectUserRoleGroup(String userName) {
        List<SysRole> list = roleMapper.selectRolesByUserName(userName);
        if (CollectionUtils.isEmpty(list)) {
            return StringUtils.EMPTY;
        }
        return list.stream().map(SysRole::getRoleName).collect(Collectors.joining(","));
    }

    /**
     * 查询用户所属岗位组
     *
     * @param userName 用户名
     * @return 结果
     */
    @Override
    public String selectUserPostGroup(String userName) {
        List<SysPost> list = postMapper.selectPostsByUserName(userName);
        if (CollectionUtils.isEmpty(list)) {
            return StringUtils.EMPTY;
        }
        return list.stream().map(SysPost::getPostName).collect(Collectors.joining(","));
    }

    /**
     * 校验用户名称是否唯一
     *
     * @param userName 用户名称
     * @return 结果
     */
    @Override
    public String checkUserNameUnique(String userName) {
        int count = userMapper.checkUserNameUnique(userName);
        if (count > 0) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 校验手机号码是否唯一
     *
     * @param user 用户信息
     * @return
     */
    @Override
    public String checkPhoneUnique(SysUser user) {
        Long userId = StringUtils.isNull(user.getUserId()) ? -1L : user.getUserId();
        SysUser info = userMapper.checkPhoneUnique(user.getPhonenumber());
        if (StringUtils.isNotNull(info) && info.getUserId().longValue() != userId.longValue()) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 校验email是否唯一
     *
     * @param user 用户信息
     * @return
     */
    @Override
    public String checkEmailUnique(SysUser user) {
        Long userId = StringUtils.isNull(user.getUserId()) ? -1L : user.getUserId();
        SysUser info = userMapper.checkEmailUnique(user.getEmail());
        if (StringUtils.isNotNull(info) && info.getUserId().longValue() != userId.longValue()) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 校验用户是否允许操作
     *
     * @param user 用户信息
     */
    @Override
    public void checkUserAllowed(SysUser user) {
        if (StringUtils.isNotNull(user.getUserId()) && user.isAdmin()) {
            throw new ServiceException("不允许操作超级管理员用户");
        }
    }

    /**
     * 校验用户是否有数据权限
     *
     * @param userId 用户id
     */
    @Override
    public void checkUserDataScope(Long userId) {
        if (!SysUser.isAdmin(SecurityUtils.getUserId())) {
            SysUserListReq sysUserReq = new SysUserListReq();
            sysUserReq.setUserId(userId);
            List<SysUser> users = SpringUtils.getAopProxy(this).selectUserList(sysUserReq);
            if (StringUtils.isEmpty(users)) {
                throw new ServiceException("没有权限访问用户数据！");
            }
        }
    }

    /**
     * 新增保存用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    @Transactional
    public int insertUser(SysUser user) {
        // 新增用户信息
        int rows = userMapper.insert(user);
        // 新增用户岗位关联
        insertUserPost(user);
        // 新增用户与角色管理
        insertUserRole(user);
        return rows;
    }

    /**
     * 注册用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public boolean registerUser(SysUser user) {
        return userMapper.insertUser(user) > 0;
    }

    /**
     * 修改保存用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    @Transactional
    public int updateUser(SysUser user) {
        Long userId = user.getUserId();
        // 删除用户与角色关联
        userRoleMapper.deleteUserRoleByUserId(userId);
        // 新增用户与角色管理
        insertUserRole(user);
        // 删除用户与岗位关联
        userPostMapper.deleteUserPostByUserId(userId);
        // 新增用户与岗位管理
        insertUserPost(user);
        return userMapper.updateById(user);
    }

    @Override
    @Transactional
    public Response batchDelUser(List<Long> ids) {
        ids.stream().map(id -> {
            SysUser sysUser = new SysUser();
            sysUser.setUserId(id);
            sysUser.setDelFlag("1");
            sysUser.setStatus("1");
           /* QueryWrapper<SysUser> wrapper = new QueryWrapper<>();
            wrapper.eq("user_id" , id);
            userMapper.update(sysUser, wrapper);*/
            userMapper.updateById(sysUser);
            return id;
        }).collect(Collectors.toList());

        return Response.success("OK!");
    }

    /**
     * 用户授权角色
     *
     * @param userId  用户ID
     * @param roleIds 角色组
     */
    @Override
    @Transactional
    public void insertUserAuth(Long userId, Long[] roleIds) {
        userRoleMapper.deleteUserRoleByUserId(userId);
        insertUserRole(userId, roleIds);
    }

    /**
     * 修改用户状态
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public int updateUserStatus(SysUser user) {
        return userMapper.updateUser(user);
    }

    /**
     * 修改用户基本信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public int updateUserProfile(SysUser user) {
        return userMapper.updateUser(user);
    }

    /**
     * 修改用户头像
     *
     * @param userName 用户名
     * @param avatar   头像地址
     * @return 结果
     */
    @Override
    public boolean updateUserAvatar(String userName, String avatar) {
        return userMapper.updateUserAvatar(userName, avatar) > 0;
    }

    /**
     * 重置用户密码
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public int resetPwd(SysUser user) {
        return userMapper.updateUser(user);
    }
    /**
     * 重置用户密码
     *
     * @param userName 用户名
     * @param password 密码
     * @return 结果
     */
    @Override
    public int resetUserPwd(String userName, String password) {
        return userMapper.resetUserPwd(userName, password);
    }

    /**
     * 新增用户角色信息
     *
     * @param user 用户对象
     */
    public void insertUserRole(SysUser user) {
        Long[] roles = user.getRoleIds();
        if (StringUtils.isNotNull(roles)) {
            // 新增用户与角色管理
            List<SysUserRole> list = new ArrayList<SysUserRole>();
            for (Long roleId : roles) {
                SysUserRole ur = new SysUserRole();
                ur.setUserId(user.getUserId());
                ur.setRoleId(roleId);
                list.add(ur);
            }
            if (list.size() > 0) {
                userRoleMapper.batchUserRole(list);
            }
        }
    }

    /**
     * 新增用户岗位信息
     *
     * @param user 用户对象
     */
    public void insertUserPost(SysUser user) {
        Long[] posts = user.getPostIds();
        if (StringUtils.isNotNull(posts)) {
            // 新增用户与岗位管理
            List<SysUserPost> list = new ArrayList<SysUserPost>();
            for (Long postId : posts) {
                SysUserPost up = new SysUserPost();
                up.setUserId(user.getUserId());
                up.setPostId(postId);
                list.add(up);
            }
            if (list.size() > 0) {
                userPostMapper.batchUserPost(list);
            }
        }
    }

    /**
     * 新增用户角色信息
     *
     * @param userId  用户ID
     * @param roleIds 角色组
     */
    public void insertUserRole(Long userId, Long[] roleIds) {
        if (StringUtils.isNotNull(roleIds)) {
            // 新增用户与角色管理
            List<SysUserRole> list = new ArrayList<SysUserRole>();
            for (Long roleId : roleIds) {
                SysUserRole ur = new SysUserRole();
                ur.setUserId(userId);
                ur.setRoleId(roleId);
                list.add(ur);
            }
            if (list.size() > 0) {
                userRoleMapper.batchUserRole(list);
            }
        }
    }

    /**
     * 通过用户ID删除用户
     *
     * @param userId 用户ID
     * @return 结果
     */
    @Override
    @Transactional
    public int deleteUserById(Long userId) {
        // 删除用户与角色关联
        userRoleMapper.deleteUserRoleByUserId(userId);
        // 删除用户与岗位表
        userPostMapper.deleteUserPostByUserId(userId);
        return userMapper.deleteUserById(userId);
    }

    /**
     * 批量删除用户信息
     *
     * @param userIds 需要删除的用户ID
     * @return 结果
     */
    @Override
    @Transactional
    public int deleteUserByIds(Long[] userIds) {
        for (Long userId : userIds) {
            checkUserAllowed(new SysUser(userId));
            checkUserDataScope(userId);
        }
        // 删除用户与角色关联
        userRoleMapper.deleteUserRole(userIds);
        // 删除用户与岗位关联
        userPostMapper.deleteUserPost(userIds);
        return userMapper.deleteUserByIds(userIds);
    }

    /**
     * 导入用户数据
     *
     * @param userList        用户数据列表
     * @param isUpdateSupport 是否更新支持，如果已存在，则进行更新数据
     * @param operName        操作用户
     * @return 结果
     */
    @Override
    public String importUser(List<SysUser> userList, Boolean isUpdateSupport, String operName) {
        if (StringUtils.isNull(userList) || userList.size() == 0) {
            throw new ServiceException("导入用户数据不能为空！");
        }
        int successNum = 0;
        int failureNum = 0;
        StringBuilder successMsg = new StringBuilder();
        StringBuilder failureMsg = new StringBuilder();
        String password = configService.selectConfigByKey("sys.user.initPassword");
        for (SysUser user : userList) {
            try {
                // 验证是否存在这个用户
                SysUser u = userMapper.selectUserByUserName(user.getUserName());
                if (StringUtils.isNull(u)) {
                    BeanValidators.validateWithException(validator, user);
                    user.setPassword(SecurityUtils.encryptPassword(password));
                    user.setCreateBy(operName);
                    this.insertUser(user);
                    successNum++;
                    successMsg.append("<br/>" + successNum + "、账号 " + user.getUserName() + " 导入成功");
                } else if (isUpdateSupport) {
                    BeanValidators.validateWithException(validator, user);
                    user.setUpdateBy(operName);
                    this.updateUser(user);
                    successNum++;
                    successMsg.append("<br/>" + successNum + "、账号 " + user.getUserName() + " 更新成功");
                } else {
                    failureNum++;
                    failureMsg.append("<br/>" + failureNum + "、账号 " + user.getUserName() + " 已存在");
                }
            } catch (Exception e) {
                failureNum++;
                String msg = "<br/>" + failureNum + "、账号 " + user.getUserName() + " 导入失败：";
                failureMsg.append(msg + e.getMessage());
                log.error(msg, e);
            }
        }
        if (failureNum > 0) {
            failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
            throw new ServiceException(failureMsg.toString());
        } else {
            successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
        }
        return successMsg.toString();
    }
    /**
     * 重置密码
     *
     * @param user
     * @return
     */
    @Override
    public Response resetPwd4New(SysUser user) {
        SysUser sysUser = new SysUser();
        LoginUser loginUser = SecurityUtils.getLoginUser();
        Date date = new Date();
        String name = PinYinUtils.getAllFirstLetter(user.getNickName());
//        String pwd = "@" + DateUtils.parseDateToStr(DateUtils.YYYYMMDD, user.getCreateTime()) + name;
        String pwd = "Gxq123456@";
        sysUser.setPassword(SecurityUtils.encryptPassword(pwd));
        sysUser.setUpdateTime(date);
        sysUser.setUserId(user.getUserId());
        sysUser.setUpdateBy(loginUser.getUser().getNickName());
        userMapper.updateById(sysUser);
        return Response.success();
    }


    /**
     * 创建或修改组织账号
     *
     * @param req
     * @return
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Response addOrUpdateNumber(AddOrUpdateNumberReq req) {
        SysUser user;
        if (req.getUserId() == null) {

            user = new SysUser();
            BeanUtils.copyProperties(req, user);
            user.setPassword(SecurityUtils.encryptPassword(req.getPassword())); //加密
            user.setStatus("0");//启用
            user.setUserType("0");//系统用户
            user.setCreateBy(SecurityUtils.getUsername());
            user.setCreateTime(new Date());
            String userName = user.getUserName();
            Long deptId = user.getDeptId();
            SysUserListReq sysUserReq = new SysUserListReq();
            sysUserReq.setUserName(userName);
            sysUserReq.setStatus("0");
            sysUserReq.setDelFlag("0");
            List<SysUser> sysUsers = selectUserList(sysUserReq);
            if (!ObjectUtils.isEmpty(sysUsers) && sysUsers.size() > 0) {
                throw new ServiceException("【%s】账号已经再系统中存在!", userName);
            }
            this.baseMapper.insert(user);

            // 基层部门管理员
            QueryWrapper<SysRole> sysRoleQueryWrapper = new QueryWrapper<>();
            sysRoleQueryWrapper.eq("role_name", "基层部门管理员");
            SysRole sysRole = roleMapper.selectOne(sysRoleQueryWrapper);

            //分配基层管理员的角色
            userRoleMapper.inserUserRole(user.getUserId(), sysRole.getRoleId());

        } else {
            user = this.baseMapper.selectById(req.getUserId());
            BeanUtils.copyProperties(req, user);
            user.setUpdateBy(SecurityUtils.getUsername());
            user.setUpdateTime(new Date());
            this.baseMapper.updateById(user);
        }
        return Response.success();
    }

    /**
     * 启用 停用
     *
     * @return
     */
    @Override
    public Response enableOrDeactivate(Long userId, Integer type) {
        if (!SecurityUtils.isAdmin(SecurityUtils.getUserId())) {
            return Response.error("没有权限操作！！！");
        }
        SysUser user = this.baseMapper.selectById(userId);
        if (type != null && type == 1) {
            user.setUserType("1");//停用
        } else {
            user.setUserType("0");//启用正常
        }
        this.baseMapper.updateById(user);
        return Response.success();
    }
    /**
     * 删除干部
     *
     * @param userId
     * @return
     */
    @Override
    public Response delcadre(Long userId) {

//        SysUser user = this.baseMapper.selectById(userId);
//        user.setStatus("1");//停用
//        user.setDelFlag("2");//删除
//        this.baseMapper.updateById(user);
        //将这个干部物理删除
        int i = this.baseMapper.deleteById(userId);
        return Response.success();
    }

    /**
     * 组织账号列表
     *
     * @param req
     * @return
     */
    @Override
    public Response<OrgAccPageVo> orgAccList(OrgAccReq req) {

        //权限控制
        //当前机构及子部门的
        List<Long> dIds = new ArrayList<>();
        List<SysDept> sysDepts = deptMapper.selectLevelAndChild(SecurityUtils.getDeptId());
        if (sysDepts != null && sysDepts.size() > 0) {
            for (SysDept sysDept : sysDepts) {
                dIds.add(sysDept.getDeptId());
            }
        }
        if (req.getDeptId() == null) {
            req.setDeptId(dIds);
        }

        Page<OrgAccPageVo> page = PageHelper.startPage(req.getPageNumber(), req.getPageSize());

        //查询当前机构及子部门的组织账号
        List<OrgAccRcord> rcords = this.baseMapper.orgAccList(req);

        OrgAccPageVo vo = new OrgAccPageVo();

        vo.setOrgAccRcords(rcords);

        vo.setCurrPage(req.getPageNumber());
        vo.setPageSize(req.getPageSize());
        vo.setTotalRecord(Long.valueOf(page.getTotal()).intValue());

        return Response.success(vo);

    }

    /**
     * 总部门重置为初始密码
     *
     * @param req
     * @return
     */
    @Override
    public Response unionsReset(UnionsResetReq req) {
//        QueryWrapper<SysUser> sysUserQueryWrapper = new QueryWrapper<>();
//        sysUserQueryWrapper.eq("user_id", req.getUserId());
//        sysUserQueryWrapper.eq("dept_id", req.getDeptId());
//        sysUserQueryWrapper.eq("user_type", 0);
//        sysUserQueryWrapper.eq("status", 0);
//        SysUser user = this.baseMapper.selectOne(sysUserQueryWrapper);

        SysUser user = this.baseMapper.selectById(req.getUserId());

        //总部门重置为初始密码
        String name = "tjx";
//        String pwd = "@" + DateUtils.parseDateToStr(DateUtils.YYYYMMDD, user.getCreateTime()) + name;
        String pwd = "tjxzgh@123456&";
        user.setPassword(SecurityUtils.encryptPassword(pwd));
        user.setUpdateTime(new Date());
        user.setUserId(user.getUserId());
        user.setUpdateBy(SecurityUtils.getLoginUser().getUser().getNickName());

        this.baseMapper.updateById(user);

        return Response.success();
    }
}
